#include "stdio.h"

unsigned char long_mode_support(void)
{
    unsigned int ret_val;
    __asm__ __volatile__("mov	$0x80000000, %%eax;"
			 "cpuid;"
			 "cmp	$0x80000000, %%eax;"
			 "jbe	no_long_mode;"
			 "mov	$0x80000001, %%eax;"
			 "cpuid;"
			 "bt	$29, %%edx;"
			 "jnc 	no_long_mode;"
			 "mov	$1, %0;"				//Flag 1 for long mode support
			 "no_long_mode: ;"
			: "=a" (ret_val)
			: 
			: "edx");					//Clobbered register
    return ret_val;
    
}
