#include "video.h"
#include "mem.h"
prep_image* 
planify (unsigned char* bitmap, unsigned long xsize, unsigned long ysize)   // takes data and converts into a plane-like layout.
{
	static prep_image outmap;
	outmap.bitmap = malloc (xsize*ysize);
		
	unsigned ly,lx=0;
	for (ly=0; ly < ysize; ly++) 				//for 0 to bitmap Ysize do
	{
		for (lx=0; lx < xsize-1;lx+=4)
		{
		
			outmap.bitmap[xsize*ly+lx]=bitmap[ly*xsize+lx];
			outmap.bitmap[xsize*ly+lx+(xsize >> 2 *1) +ly]= bitmap[ly*xsize+lx+1];
			outmap.bitmap [xsize*ly+lx+( xsize >> 2 *2) +ly]= bitmap[ly*xsize+lx+2];
			outmap.bitmap [xsize*ly+lx+( xsize >> 2 *3) +ly]= bitmap[ly*xsize+lx+3];
		
			outmap.bitmap[111]='h';
			outmap.bitmap[112]='r';
			
			
		
			int ii;
			for (ii=0; ii < 3; ii++)
			{
				if (bitmap[ly*xsize+lx+ii] == 0 )
						outmap.mask[lx && 1 << ii] =0;
						else
						outmap.mask[lx && 1 << ii] = 1;
			}
					
			
		}
		
		if (xsize % 4 !=0)
		outmap.mask[lx] = 5- (4 - xsize % 4);

	}	

//	int kuk;
//	for (kuk=0; kuk < 160; kuk++)
//		outmap.bitmap[kuk]= 1;	
	return &outmap;
}	
